function love.load()
  -- hook up profiler
  love.profiler = require('profile')  
  -- use Love's timer instead of os.clock
  love.profiler.setclock(love.timer.getTime)
  -- hook only Lua functions
  love.profiler.hookall("Lua")
  -- start profiling
  love.profiler.start()
end

love.frame = 0

function love.update(dt)
  love.frame = love.frame + 1
  
  -- print report every 100th frame
  if love.frame%100 == 0 then
    -- top 20 functions sorted by execution time
    love.report = love.profiler.report('time', 20)
    -- reset profiling data
    love.profiler.reset()
  end
end

function love.draw()
  local out = "Frame:" .. love.frame .. "\n"
  out = out .. "Memory:" .. collectgarbage('count') .. "\n"
  out = out .. (love.report or "Please wait...")
  love.graphics.print(out)
end
